/* Generated by Frama-C */
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"
extern  __attribute__((__FC_BUILTIN__)) int __e_acsl_sound_verdict;

/*@
predicate p1(integer i, integer j, integer k) =
  0 <= i < 10 && 1 < j <= 11 && 2 <= k <= 12;
 */
int __gen_e_acsl_p1(int i, int j, int k);

/*@ predicate p2(integer i, integer j, integer k) = 0 <= i <= j < k <= 10;
 */
int __gen_e_acsl_p2(int i, int j, int k);

/*@
predicate p3(integer i, integer j, integer k) =
  0 <= i < j <= 10 && 1 < k < 11;
 */
int __gen_e_acsl_p3(int i, int j, int k);

/*@
predicate p4(integer i, integer j, integer k) =
  0 <= i <= k <= 10 && 1 <= j < k;

*/
int __gen_e_acsl_p4(int i, int j, int k);

int main(void)
{
  int __retres;
  __e_acsl_memory_init((int *)0,(char ***)0,(size_t)8);
  {
    int __gen_e_acsl_forall;
    int __gen_e_acsl_x;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data = {.values = (void *)0};
    __gen_e_acsl_forall = 1;
    __gen_e_acsl_x = 0;
    while (1) {
      if (__gen_e_acsl_x <= 1) ; else break;
      {
        int __gen_e_acsl_or;
        if (__gen_e_acsl_x == 0) __gen_e_acsl_or = 1;
        else __gen_e_acsl_or = __gen_e_acsl_x == 1;
        if (__gen_e_acsl_or) ;
        else {
          __gen_e_acsl_forall = 0;
          goto e_acsl_end_loop1;
        }
      }
      __gen_e_acsl_x ++;
    }
    e_acsl_end_loop1: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data,
                                 "\\forall integer x; 0 <= x <= 1 ==> x == 0 || x == 1",
                                 0,__gen_e_acsl_forall);
    __gen_e_acsl_assert_data.blocking = 1;
    __gen_e_acsl_assert_data.kind = "Assertion";
    __gen_e_acsl_assert_data.pred_txt = "\\forall integer x; 0 <= x <= 1 ==> x == 0 || x == 1";
    __gen_e_acsl_assert_data.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data.fct = "main";
    __gen_e_acsl_assert_data.line = 16;
    __e_acsl_assert(__gen_e_acsl_forall,& __gen_e_acsl_assert_data);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data);
  }
  /*@ assert \forall integer x; 0 <= x <= 1 ==> x == 0 || x == 1; */ ;
  {
    int __gen_e_acsl_forall_2;
    int __gen_e_acsl_x_2;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_2 =
      {.values = (void *)0};
    __gen_e_acsl_forall_2 = 1;
    __gen_e_acsl_x_2 = 0 + 1;
    while (1) {
      if (__gen_e_acsl_x_2 <= 1) ; else break;
      if (__gen_e_acsl_x_2 == 1) ;
      else {
        __gen_e_acsl_forall_2 = 0;
        goto e_acsl_end_loop2;
      }
      __gen_e_acsl_x_2 ++;
    }
    e_acsl_end_loop2: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_2,
                                 "\\forall integer x; 0 < x <= 1 ==> x == 1",
                                 0,__gen_e_acsl_forall_2);
    __gen_e_acsl_assert_data_2.blocking = 1;
    __gen_e_acsl_assert_data_2.kind = "Assertion";
    __gen_e_acsl_assert_data_2.pred_txt = "\\forall integer x; 0 < x <= 1 ==> x == 1";
    __gen_e_acsl_assert_data_2.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_2.fct = "main";
    __gen_e_acsl_assert_data_2.line = 17;
    __e_acsl_assert(__gen_e_acsl_forall_2,& __gen_e_acsl_assert_data_2);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_2);
  }
  /*@ assert \forall integer x; 0 < x <= 1 ==> x == 1; */ ;
  {
    int __gen_e_acsl_forall_3;
    int __gen_e_acsl_x_3;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_3 =
      {.values = (void *)0};
    __gen_e_acsl_forall_3 = 1;
    __gen_e_acsl_x_3 = 0;
    while (1) {
      if (__gen_e_acsl_x_3 < 1) ; else break;
      if (__gen_e_acsl_x_3 == 0) ;
      else {
        __gen_e_acsl_forall_3 = 0;
        goto e_acsl_end_loop3;
      }
      __gen_e_acsl_x_3 ++;
    }
    e_acsl_end_loop3: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_3,
                                 "\\forall integer x; 0 <= x < 1 ==> x == 0",
                                 0,__gen_e_acsl_forall_3);
    __gen_e_acsl_assert_data_3.blocking = 1;
    __gen_e_acsl_assert_data_3.kind = "Assertion";
    __gen_e_acsl_assert_data_3.pred_txt = "\\forall integer x; 0 <= x < 1 ==> x == 0";
    __gen_e_acsl_assert_data_3.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_3.fct = "main";
    __gen_e_acsl_assert_data_3.line = 18;
    __e_acsl_assert(__gen_e_acsl_forall_3,& __gen_e_acsl_assert_data_3);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_3);
  }
  /*@ assert \forall integer x; 0 <= x < 1 ==> x == 0; */ ;
  {
    int __gen_e_acsl_forall_4;
    int __gen_e_acsl_x_4;
    int __gen_e_acsl_y;
    int __gen_e_acsl_z;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_4 =
      {.values = (void *)0};
    __gen_e_acsl_forall_4 = 1;
    __gen_e_acsl_x_4 = 0;
    while (1) {
      if (__gen_e_acsl_x_4 < 2) ; else break;
      __gen_e_acsl_y = 0;
      while (1) {
        if (__gen_e_acsl_y < 5) ; else break;
        __gen_e_acsl_z = 0;
        while (1) {
          if (__gen_e_acsl_z <= __gen_e_acsl_y) ; else break;
          if (__gen_e_acsl_x_4 + __gen_e_acsl_z <= __gen_e_acsl_y + 1) 
            ;
          else {
            __gen_e_acsl_forall_4 = 0;
            goto e_acsl_end_loop4;
          }
          __gen_e_acsl_z ++;
        }
        __gen_e_acsl_y ++;
      }
      __gen_e_acsl_x_4 ++;
    }
    e_acsl_end_loop4: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_4,
                                 "\\forall integer x, integer y, integer z;\n  0 <= x < 2 && 0 <= y < 5 && 0 <= z <= y ==> x + z <= y + 1",
                                 0,__gen_e_acsl_forall_4);
    __gen_e_acsl_assert_data_4.blocking = 1;
    __gen_e_acsl_assert_data_4.kind = "Assertion";
    __gen_e_acsl_assert_data_4.pred_txt = "\\forall integer x, integer y, integer z;\n  0 <= x < 2 && 0 <= y < 5 && 0 <= z <= y ==> x + z <= y + 1";
    __gen_e_acsl_assert_data_4.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_4.fct = "main";
    __gen_e_acsl_assert_data_4.line = 22;
    __e_acsl_assert(__gen_e_acsl_forall_4,& __gen_e_acsl_assert_data_4);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_4);
  }
  /*@
  assert
  \forall integer x, integer y, integer z;
    0 <= x < 2 && 0 <= y < 5 && 0 <= z <= y ==> x + z <= y + 1;
   */
  ;
  {
    int __gen_e_acsl_exists;
    int __gen_e_acsl_x_5;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_5 =
      {.values = (void *)0};
    __gen_e_acsl_exists = 0;
    __gen_e_acsl_x_5 = 0;
    while (1) {
      if (__gen_e_acsl_x_5 < 10) ; else break;
      if (! (__gen_e_acsl_x_5 == 5)) ;
      else {
        __gen_e_acsl_exists = 1;
        goto e_acsl_end_loop5;
      }
      __gen_e_acsl_x_5 ++;
    }
    e_acsl_end_loop5: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_5,
                                 "\\exists int x; 0 <= x < 10 && x == 5",0,
                                 __gen_e_acsl_exists);
    __gen_e_acsl_assert_data_5.blocking = 1;
    __gen_e_acsl_assert_data_5.kind = "Assertion";
    __gen_e_acsl_assert_data_5.pred_txt = "\\exists int x; 0 <= x < 10 && x == 5";
    __gen_e_acsl_assert_data_5.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_5.fct = "main";
    __gen_e_acsl_assert_data_5.line = 27;
    __e_acsl_assert(__gen_e_acsl_exists,& __gen_e_acsl_assert_data_5);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_5);
  }
  /*@ assert \exists int x; 0 <= x < 10 && x == 5; */ ;
  {
    int __gen_e_acsl_forall_5;
    int __gen_e_acsl_x_6;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_6 =
      {.values = (void *)0};
    __gen_e_acsl_forall_5 = 1;
    __gen_e_acsl_x_6 = 0;
    while (1) {
      if (__gen_e_acsl_x_6 < 10) ; else break;
      {
        int __gen_e_acsl_implies;
        if (! (__gen_e_acsl_x_6 % 2 == 0)) __gen_e_acsl_implies = 1;
        else {
          int __gen_e_acsl_exists_2;
          int __gen_e_acsl_y_2;
          __gen_e_acsl_exists_2 = 0;
          __gen_e_acsl_y_2 = 0;
          while (1) {
            if (__gen_e_acsl_y_2 <= __gen_e_acsl_x_6 / 2) ; else break;
            if (! (__gen_e_acsl_x_6 == 2 * __gen_e_acsl_y_2)) ;
            else {
              __gen_e_acsl_exists_2 = 1;
              goto e_acsl_end_loop6;
            }
            __gen_e_acsl_y_2 ++;
          }
          e_acsl_end_loop6: ;
          __gen_e_acsl_implies = __gen_e_acsl_exists_2;
        }
        if (__gen_e_acsl_implies) ;
        else {
          __gen_e_acsl_forall_5 = 0;
          goto e_acsl_end_loop7;
        }
      }
      __gen_e_acsl_x_6 ++;
    }
    e_acsl_end_loop7: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_6,
                                 "\\forall int x;\n  0 <= x < 10 ==>\n  x % 2 == 0 ==> (\\exists integer y; 0 <= y <= x / 2 && x == 2 * y)",
                                 0,__gen_e_acsl_forall_5);
    __gen_e_acsl_assert_data_6.blocking = 1;
    __gen_e_acsl_assert_data_6.kind = "Assertion";
    __gen_e_acsl_assert_data_6.pred_txt = "\\forall int x;\n  0 <= x < 10 ==>\n  x % 2 == 0 ==> (\\exists integer y; 0 <= y <= x / 2 && x == 2 * y)";
    __gen_e_acsl_assert_data_6.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_6.fct = "main";
    __gen_e_acsl_assert_data_6.line = 31;
    __e_acsl_assert(__gen_e_acsl_forall_5,& __gen_e_acsl_assert_data_6);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_6);
  }
  /*@
  assert
  \forall int x;
    0 <= x < 10 ==>
    x % 2 == 0 ==> (\exists integer y; 0 <= y <= x / 2 && x == 2 * y);
   */
  ;
  {
    int buf[10];
    __e_acsl_store_block((void *)(buf),(size_t)40);
    unsigned long len = (unsigned long)9;
    {
      int __gen_e_acsl_forall_6;
      int __gen_e_acsl_i;
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_7 =
        {.values = (void *)0};
      __gen_e_acsl_forall_6 = 1;
      __gen_e_acsl_i = 0;
      while (1) {
        if (__gen_e_acsl_i < 10) ; else break;
        {
          int __gen_e_acsl_valid;
          __gen_e_acsl_valid = __e_acsl_valid((void *)(& buf[__gen_e_acsl_i]),
                                              sizeof(int),(void *)(buf),
                                              (void *)0);
          if (__gen_e_acsl_valid) ;
          else {
            __gen_e_acsl_forall_6 = 0;
            goto e_acsl_end_loop8;
          }
        }
        __gen_e_acsl_i ++;
      }
      e_acsl_end_loop8: ;
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_7,
                                   "\\forall integer i; 0 <= i < 10 ==> \\valid(&buf[i])",
                                   0,__gen_e_acsl_forall_6);
      __gen_e_acsl_assert_data_7.blocking = 1;
      __gen_e_acsl_assert_data_7.kind = "Assertion";
      __gen_e_acsl_assert_data_7.pred_txt = "\\forall integer i; 0 <= i < 10 ==> \\valid(&buf[i])";
      __gen_e_acsl_assert_data_7.file = "tests/arith/quantif.i";
      __gen_e_acsl_assert_data_7.fct = "main";
      __gen_e_acsl_assert_data_7.line = 37;
      __e_acsl_assert(__gen_e_acsl_forall_6,& __gen_e_acsl_assert_data_7);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_7);
    }
    /*@ assert \forall integer i; 0 <= i < 10 ==> \valid(&buf[i]); */ ;
    {
      int __gen_e_acsl_forall_7;
      int __gen_e_acsl_i_2;
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_8 =
        {.values = (void *)0};
      __gen_e_acsl_forall_7 = 1;
      __gen_e_acsl_i_2 = (char)0;
      while (1) {
        if (__gen_e_acsl_i_2 < 10) ; else break;
        {
          int __gen_e_acsl_valid_2;
          __gen_e_acsl_valid_2 = __e_acsl_valid((void *)(& buf[__gen_e_acsl_i_2]),
                                                sizeof(int),(void *)(buf),
                                                (void *)0);
          if (__gen_e_acsl_valid_2) ;
          else {
            __gen_e_acsl_forall_7 = 0;
            goto e_acsl_end_loop9;
          }
        }
        __gen_e_acsl_i_2 ++;
      }
      e_acsl_end_loop9: ;
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_8,
                                   "\\forall char i; 0 <= i < 10 ==> \\valid(&buf[i])",
                                   0,__gen_e_acsl_forall_7);
      __gen_e_acsl_assert_data_8.blocking = 1;
      __gen_e_acsl_assert_data_8.kind = "Assertion";
      __gen_e_acsl_assert_data_8.pred_txt = "\\forall char i; 0 <= i < 10 ==> \\valid(&buf[i])";
      __gen_e_acsl_assert_data_8.file = "tests/arith/quantif.i";
      __gen_e_acsl_assert_data_8.fct = "main";
      __gen_e_acsl_assert_data_8.line = 38;
      __e_acsl_assert(__gen_e_acsl_forall_7,& __gen_e_acsl_assert_data_8);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_8);
    }
    /*@ assert \forall char i; 0 <= i < 10 ==> \valid(&buf[i]); */ ;
    {
      int __gen_e_acsl_forall_8;
      unsigned long __gen_e_acsl_i_3;
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_9 =
        {.values = (void *)0};
      __gen_e_acsl_forall_8 = 1;
      __gen_e_acsl_i_3 = 0UL;
      while (1) {
        if (__gen_e_acsl_i_3 < len) ; else break;
        {
          int __gen_e_acsl_valid_3;
          __gen_e_acsl_valid_3 = __e_acsl_valid((void *)(& buf[__gen_e_acsl_i_3]),
                                                sizeof(int),(void *)(buf),
                                                (void *)0);
          if (__gen_e_acsl_valid_3) ;
          else {
            __gen_e_acsl_forall_8 = 0;
            goto e_acsl_end_loop10;
          }
        }
        __gen_e_acsl_i_3 ++;
      }
      e_acsl_end_loop10: ;
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_9,
                                   "\\forall integer i; 0 <= i < len ==> \\valid(&buf[i])",
                                   0,__gen_e_acsl_forall_8);
      __gen_e_acsl_assert_data_9.blocking = 1;
      __gen_e_acsl_assert_data_9.kind = "Assertion";
      __gen_e_acsl_assert_data_9.pred_txt = "\\forall integer i; 0 <= i < len ==> \\valid(&buf[i])";
      __gen_e_acsl_assert_data_9.file = "tests/arith/quantif.i";
      __gen_e_acsl_assert_data_9.fct = "main";
      __gen_e_acsl_assert_data_9.line = 39;
      __e_acsl_assert(__gen_e_acsl_forall_8,& __gen_e_acsl_assert_data_9);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_9);
    }
    /*@ assert \forall integer i; 0 <= i < len ==> \valid(&buf[i]); */ ;
    {
      int __gen_e_acsl_forall_9;
      __e_acsl_mpz_t __gen_e_acsl_i_4;
      __e_acsl_assert_data_t __gen_e_acsl_assert_data_10 =
        {.values = (void *)0};
      __gen_e_acsl_forall_9 = 1;
      __gmpz_init(__gen_e_acsl_i_4);
      {
        __e_acsl_mpz_t __gen_e_acsl_;
        __gmpz_init_set_si(__gen_e_acsl_,0L);
        __gmpz_set(__gen_e_acsl_i_4,
                   (__e_acsl_mpz_struct const *)(__gen_e_acsl_));
        __gmpz_clear(__gen_e_acsl_);
      }
      while (1) {
        {
          __e_acsl_mpz_t __gen_e_acsl_len;
          int __gen_e_acsl_le;
          __gmpz_init_set_ui(__gen_e_acsl_len,len);
          __gen_e_acsl_le = __gmpz_cmp((__e_acsl_mpz_struct const *)(__gen_e_acsl_i_4),
                                       (__e_acsl_mpz_struct const *)(__gen_e_acsl_len));
          if (__gen_e_acsl_le <= 0) ; else break;
          __gmpz_clear(__gen_e_acsl_len);
        }
        {
          long __gen_e_acsl_i_5;
          int __gen_e_acsl_valid_4;
          __gen_e_acsl_i_5 = __gmpz_get_si((__e_acsl_mpz_struct const *)(__gen_e_acsl_i_4));
          __gen_e_acsl_valid_4 = __e_acsl_valid((void *)(& buf[__gen_e_acsl_i_5]),
                                                sizeof(int),(void *)(buf),
                                                (void *)0);
          if (__gen_e_acsl_valid_4) ;
          else {
            __gen_e_acsl_forall_9 = 0;
            goto e_acsl_end_loop11;
          }
        }
        {
          __e_acsl_mpz_t __gen_e_acsl__2;
          __e_acsl_mpz_t __gen_e_acsl_add;
          __gmpz_init_set_str(__gen_e_acsl__2,"1",10);
          __gmpz_init(__gen_e_acsl_add);
          __gmpz_add(__gen_e_acsl_add,
                     (__e_acsl_mpz_struct const *)(__gen_e_acsl_i_4),
                     (__e_acsl_mpz_struct const *)(__gen_e_acsl__2));
          __gmpz_set(__gen_e_acsl_i_4,
                     (__e_acsl_mpz_struct const *)(__gen_e_acsl_add));
          __gmpz_clear(__gen_e_acsl__2);
          __gmpz_clear(__gen_e_acsl_add);
        }
      }
      e_acsl_end_loop11: ;
      __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_10,
                                   "\\forall integer i; 0 <= i <= len ==> \\valid(&buf[i])",
                                   0,__gen_e_acsl_forall_9);
      __gen_e_acsl_assert_data_10.blocking = 1;
      __gen_e_acsl_assert_data_10.kind = "Assertion";
      __gen_e_acsl_assert_data_10.pred_txt = "\\forall integer i; 0 <= i <= len ==> \\valid(&buf[i])";
      __gen_e_acsl_assert_data_10.file = "tests/arith/quantif.i";
      __gen_e_acsl_assert_data_10.fct = "main";
      __gen_e_acsl_assert_data_10.line = 40;
      __e_acsl_assert(__gen_e_acsl_forall_9,& __gen_e_acsl_assert_data_10);
      __e_acsl_assert_clean(& __gen_e_acsl_assert_data_10);
      __gmpz_clear(__gen_e_acsl_i_4);
    }
    /*@ assert \forall integer i; 0 <= i <= len ==> \valid(&buf[i]); */ ;
    __e_acsl_delete_block((void *)(buf));
  }
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_11 =
      {.values = (void *)0};
    __gen_e_acsl_assert_data_11.blocking = 1;
    __gen_e_acsl_assert_data_11.kind = "Assertion";
    __gen_e_acsl_assert_data_11.pred_txt = "\\forall integer x; 0 < x < 1 ==> \\false";
    __gen_e_acsl_assert_data_11.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_11.fct = "main";
    __gen_e_acsl_assert_data_11.line = 44;
    __e_acsl_assert(1,& __gen_e_acsl_assert_data_11);
  }
  /*@ assert \forall integer x; 0 < x < 1 ==> \false; */ ;
  {
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_12 =
      {.values = (void *)0};
    __gen_e_acsl_assert_data_12.blocking = 1;
    __gen_e_acsl_assert_data_12.kind = "Assertion";
    __gen_e_acsl_assert_data_12.pred_txt = "!(\\exists char c; 10 <= c < 10 && c == 10)";
    __gen_e_acsl_assert_data_12.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_12.fct = "main";
    __gen_e_acsl_assert_data_12.line = 45;
    __e_acsl_assert(1,& __gen_e_acsl_assert_data_12);
  }
  /*@ assert !(\exists char c; 10 <= c < 10 && c == 10); */ ;
  {
    int __gen_e_acsl_u;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_13 =
      {.values = (void *)0};
    __gen_e_acsl_u = 5;
    __gen_e_acsl_assert_data_13.blocking = 1;
    __gen_e_acsl_assert_data_13.kind = "Assertion";
    __gen_e_acsl_assert_data_13.pred_txt = "\\let u = 5;\n\\forall integer x, integer y; 0 <= x < 2 && 4 < y < u ==> \\false";
    __gen_e_acsl_assert_data_13.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_13.fct = "main";
    __gen_e_acsl_assert_data_13.line = 47;
    __e_acsl_assert(1,& __gen_e_acsl_assert_data_13);
  }
  /*@
  assert \let u = 5;
  \forall integer x, integer y; 0 <= x < 2 && 4 < y < u ==> \false; */
  ;
  {
    int __gen_e_acsl_forall_10;
    int __gen_e_acsl_i_6;
    int __gen_e_acsl_j;
    int __gen_e_acsl_k;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_14 =
      {.values = (void *)0};
    __gen_e_acsl_forall_10 = 1;
    __gen_e_acsl_i_6 = 0;
    while (1) {
      if (__gen_e_acsl_i_6 < 10) ; else break;
      __gen_e_acsl_j = 1 + 1;
      while (1) {
        if (__gen_e_acsl_j <= 11) ; else break;
        __gen_e_acsl_k = 2;
        while (1) {
          if (__gen_e_acsl_k <= 12) ; else break;
          {
            int __gen_e_acsl_p1_2;
            __gen_e_acsl_p1_2 = __gen_e_acsl_p1(__gen_e_acsl_i_6,
                                                __gen_e_acsl_j,
                                                __gen_e_acsl_k);
            if (__gen_e_acsl_p1_2) ;
            else {
              __gen_e_acsl_forall_10 = 0;
              goto e_acsl_end_loop12;
            }
          }
          __gen_e_acsl_k ++;
        }
        __gen_e_acsl_j ++;
      }
      __gen_e_acsl_i_6 ++;
    }
    e_acsl_end_loop12: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_14,
                                 "forall_multiple_binders_1:\n  \\forall integer i, integer j, integer k;\n    0 <= i < 10 && 1 < j <= 11 && 2 <= k <= 12 ==> p1(i, j, k)",
                                 0,__gen_e_acsl_forall_10);
    __gen_e_acsl_assert_data_14.blocking = 1;
    __gen_e_acsl_assert_data_14.kind = "Assertion";
    __gen_e_acsl_assert_data_14.pred_txt = "forall_multiple_binders_1:\n  \\forall integer i, integer j, integer k;\n    0 <= i < 10 && 1 < j <= 11 && 2 <= k <= 12 ==> p1(i, j, k)";
    __gen_e_acsl_assert_data_14.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_14.fct = "main";
    __gen_e_acsl_assert_data_14.line = 53;
    __e_acsl_assert(__gen_e_acsl_forall_10,& __gen_e_acsl_assert_data_14);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_14);
  }
  /*@
  assert
  forall_multiple_binders_1:
    \forall integer i, integer j, integer k;
      0 <= i < 10 && 1 < j <= 11 && 2 <= k <= 12 ==> p1(i, j, k);
   */
  ;
  {
    int __gen_e_acsl_forall_11;
    int __gen_e_acsl_i_7;
    int __gen_e_acsl_j_2;
    int __gen_e_acsl_k_2;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_15 =
      {.values = (void *)0};
    __gen_e_acsl_forall_11 = 1;
    __gen_e_acsl_i_7 = 0;
    while (1) {
      if (__gen_e_acsl_i_7 < 10) ; else break;
      __gen_e_acsl_j_2 = __gen_e_acsl_i_7;
      while (1) {
        if (__gen_e_acsl_j_2 < 10) ; else break;
        __gen_e_acsl_k_2 = __gen_e_acsl_j_2 + 1;
        while (1) {
          if (__gen_e_acsl_k_2 <= 10) ; else break;
          {
            int __gen_e_acsl_p2_2;
            __gen_e_acsl_p2_2 = __gen_e_acsl_p2(__gen_e_acsl_i_7,
                                                __gen_e_acsl_j_2,
                                                __gen_e_acsl_k_2);
            if (__gen_e_acsl_p2_2) ;
            else {
              __gen_e_acsl_forall_11 = 0;
              goto e_acsl_end_loop13;
            }
          }
          __gen_e_acsl_k_2 ++;
        }
        __gen_e_acsl_j_2 ++;
      }
      __gen_e_acsl_i_7 ++;
    }
    e_acsl_end_loop13: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_15,
                                 "forall_multiple_binders_2:\n  \\forall integer i, integer j, integer k;\n    0 <= i <= j < k <= 10 ==> p2(i, j, k)",
                                 0,__gen_e_acsl_forall_11);
    __gen_e_acsl_assert_data_15.blocking = 1;
    __gen_e_acsl_assert_data_15.kind = "Assertion";
    __gen_e_acsl_assert_data_15.pred_txt = "forall_multiple_binders_2:\n  \\forall integer i, integer j, integer k;\n    0 <= i <= j < k <= 10 ==> p2(i, j, k)";
    __gen_e_acsl_assert_data_15.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_15.fct = "main";
    __gen_e_acsl_assert_data_15.line = 56;
    __e_acsl_assert(__gen_e_acsl_forall_11,& __gen_e_acsl_assert_data_15);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_15);
  }
  /*@
  assert
  forall_multiple_binders_2:
    \forall integer i, integer j, integer k;
      0 <= i <= j < k <= 10 ==> p2(i, j, k);
   */
  ;
  {
    int __gen_e_acsl_forall_12;
    int __gen_e_acsl_i_8;
    int __gen_e_acsl_j_3;
    int __gen_e_acsl_k_3;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_16 =
      {.values = (void *)0};
    __gen_e_acsl_forall_12 = 1;
    __gen_e_acsl_i_8 = 0;
    while (1) {
      if (__gen_e_acsl_i_8 < 10) ; else break;
      __gen_e_acsl_j_3 = __gen_e_acsl_i_8 + 1;
      while (1) {
        if (__gen_e_acsl_j_3 <= 10) ; else break;
        __gen_e_acsl_k_3 = 1 + 1;
        while (1) {
          if (__gen_e_acsl_k_3 < 11) ; else break;
          {
            int __gen_e_acsl_p3_2;
            __gen_e_acsl_p3_2 = __gen_e_acsl_p3(__gen_e_acsl_i_8,
                                                __gen_e_acsl_j_3,
                                                __gen_e_acsl_k_3);
            if (__gen_e_acsl_p3_2) ;
            else {
              __gen_e_acsl_forall_12 = 0;
              goto e_acsl_end_loop14;
            }
          }
          __gen_e_acsl_k_3 ++;
        }
        __gen_e_acsl_j_3 ++;
      }
      __gen_e_acsl_i_8 ++;
    }
    e_acsl_end_loop14: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_16,
                                 "forall_multiple_binders_3:\n  \\forall integer i, integer j, integer k;\n    0 <= i < j <= 10 && 1 < k < 11 ==> p3(i, j, k)",
                                 0,__gen_e_acsl_forall_12);
    __gen_e_acsl_assert_data_16.blocking = 1;
    __gen_e_acsl_assert_data_16.kind = "Assertion";
    __gen_e_acsl_assert_data_16.pred_txt = "forall_multiple_binders_3:\n  \\forall integer i, integer j, integer k;\n    0 <= i < j <= 10 && 1 < k < 11 ==> p3(i, j, k)";
    __gen_e_acsl_assert_data_16.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_16.fct = "main";
    __gen_e_acsl_assert_data_16.line = 59;
    __e_acsl_assert(__gen_e_acsl_forall_12,& __gen_e_acsl_assert_data_16);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_16);
  }
  /*@
  assert
  forall_multiple_binders_3:
    \forall integer i, integer j, integer k;
      0 <= i < j <= 10 && 1 < k < 11 ==> p3(i, j, k);
   */
  ;
  {
    int __gen_e_acsl_forall_13;
    int __gen_e_acsl_i_9;
    int __gen_e_acsl_j_4;
    int __gen_e_acsl_k_4;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_17 =
      {.values = (void *)0};
    __gen_e_acsl_forall_13 = 1;
    __gen_e_acsl_i_9 = 0;
    while (1) {
      if (__gen_e_acsl_i_9 < 10) ; else break;
      __gen_e_acsl_j_4 = 1 + 1;
      while (1) {
        if (__gen_e_acsl_j_4 <= 11) ; else break;
        __gen_e_acsl_k_4 = 2;
        while (1) {
          if (__gen_e_acsl_k_4 <= 12) ; else break;
          {
            int __gen_e_acsl_p1_4;
            __gen_e_acsl_p1_4 = __gen_e_acsl_p1(__gen_e_acsl_i_9,
                                                __gen_e_acsl_j_4,
                                                __gen_e_acsl_k_4);
            if (__gen_e_acsl_p1_4) ;
            else {
              __gen_e_acsl_forall_13 = 0;
              goto e_acsl_end_loop15;
            }
          }
          __gen_e_acsl_k_4 ++;
        }
        __gen_e_acsl_j_4 ++;
      }
      __gen_e_acsl_i_9 ++;
    }
    e_acsl_end_loop15: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_17,
                                 "forall_multiple_binders_4:\n  \\forall integer i, integer j, integer k;\n    0 <= i < 10 ==> 1 < j <= 11 ==> 2 <= k <= 12 ==> p1(i, j, k)",
                                 0,__gen_e_acsl_forall_13);
    __gen_e_acsl_assert_data_17.blocking = 1;
    __gen_e_acsl_assert_data_17.kind = "Assertion";
    __gen_e_acsl_assert_data_17.pred_txt = "forall_multiple_binders_4:\n  \\forall integer i, integer j, integer k;\n    0 <= i < 10 ==> 1 < j <= 11 ==> 2 <= k <= 12 ==> p1(i, j, k)";
    __gen_e_acsl_assert_data_17.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_17.fct = "main";
    __gen_e_acsl_assert_data_17.line = 62;
    __e_acsl_assert(__gen_e_acsl_forall_13,& __gen_e_acsl_assert_data_17);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_17);
  }
  /*@
  assert
  forall_multiple_binders_4:
    \forall integer i, integer j, integer k;
      0 <= i < 10 ==> 1 < j <= 11 ==> 2 <= k <= 12 ==> p1(i, j, k);
   */
  ;
  {
    int __gen_e_acsl_forall_14;
    int __gen_e_acsl_i_10;
    int __gen_e_acsl_k_5;
    int __gen_e_acsl_j_5;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_18 =
      {.values = (void *)0};
    __gen_e_acsl_forall_14 = 1;
    __gen_e_acsl_i_10 = 0;
    while (1) {
      if (__gen_e_acsl_i_10 <= 10) ; else break;
      __gen_e_acsl_k_5 = __gen_e_acsl_i_10;
      while (1) {
        if (__gen_e_acsl_k_5 <= 10) ; else break;
        __gen_e_acsl_j_5 = 1;
        while (1) {
          if (__gen_e_acsl_j_5 < __gen_e_acsl_k_5) ; else break;
          {
            int __gen_e_acsl_p4_2;
            __gen_e_acsl_p4_2 = __gen_e_acsl_p4(__gen_e_acsl_i_10,
                                                __gen_e_acsl_j_5,
                                                __gen_e_acsl_k_5);
            if (__gen_e_acsl_p4_2) ;
            else {
              __gen_e_acsl_forall_14 = 0;
              goto e_acsl_end_loop16;
            }
          }
          __gen_e_acsl_j_5 ++;
        }
        __gen_e_acsl_k_5 ++;
      }
      __gen_e_acsl_i_10 ++;
    }
    e_acsl_end_loop16: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_18,
                                 "forall_unordered_binders:\n  \\forall integer i, integer j, integer k;\n    0 <= i <= k <= 10 && 1 <= j < k ==> p4(i, j, k)",
                                 0,__gen_e_acsl_forall_14);
    __gen_e_acsl_assert_data_18.blocking = 1;
    __gen_e_acsl_assert_data_18.kind = "Assertion";
    __gen_e_acsl_assert_data_18.pred_txt = "forall_unordered_binders:\n  \\forall integer i, integer j, integer k;\n    0 <= i <= k <= 10 && 1 <= j < k ==> p4(i, j, k)";
    __gen_e_acsl_assert_data_18.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_18.fct = "main";
    __gen_e_acsl_assert_data_18.line = 65;
    __e_acsl_assert(__gen_e_acsl_forall_14,& __gen_e_acsl_assert_data_18);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_18);
  }
  /*@
  assert
  forall_unordered_binders:
    \forall integer i, integer j, integer k;
      0 <= i <= k <= 10 && 1 <= j < k ==> p4(i, j, k);
   */
  ;
  {
    int __gen_e_acsl_exists_3;
    int __gen_e_acsl_i_11;
    int __gen_e_acsl_j_6;
    int __gen_e_acsl_k_6;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_19 =
      {.values = (void *)0};
    __gen_e_acsl_exists_3 = 0;
    __gen_e_acsl_i_11 = 0;
    while (1) {
      if (__gen_e_acsl_i_11 < 10) ; else break;
      __gen_e_acsl_j_6 = 1 + 1;
      while (1) {
        if (__gen_e_acsl_j_6 <= 11) ; else break;
        __gen_e_acsl_k_6 = 2;
        while (1) {
          if (__gen_e_acsl_k_6 <= 12) ; else break;
          {
            int __gen_e_acsl_p1_6;
            __gen_e_acsl_p1_6 = __gen_e_acsl_p1(__gen_e_acsl_i_11,
                                                __gen_e_acsl_j_6,
                                                __gen_e_acsl_k_6);
            if (! __gen_e_acsl_p1_6) ;
            else {
              __gen_e_acsl_exists_3 = 1;
              goto e_acsl_end_loop17;
            }
          }
          __gen_e_acsl_k_6 ++;
        }
        __gen_e_acsl_j_6 ++;
      }
      __gen_e_acsl_i_11 ++;
    }
    e_acsl_end_loop17: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_19,
                                 "exists_multiple_binders_1:\n  \\exists integer i, integer j, integer k;\n    0 <= i < 10 && 1 < j <= 11 && 2 <= k <= 12 && p1(i, j, k)",
                                 0,__gen_e_acsl_exists_3);
    __gen_e_acsl_assert_data_19.blocking = 1;
    __gen_e_acsl_assert_data_19.kind = "Assertion";
    __gen_e_acsl_assert_data_19.pred_txt = "exists_multiple_binders_1:\n  \\exists integer i, integer j, integer k;\n    0 <= i < 10 && 1 < j <= 11 && 2 <= k <= 12 && p1(i, j, k)";
    __gen_e_acsl_assert_data_19.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_19.fct = "main";
    __gen_e_acsl_assert_data_19.line = 68;
    __e_acsl_assert(__gen_e_acsl_exists_3,& __gen_e_acsl_assert_data_19);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_19);
  }
  /*@
  assert
  exists_multiple_binders_1:
    \exists integer i, integer j, integer k;
      0 <= i < 10 && 1 < j <= 11 && 2 <= k <= 12 && p1(i, j, k);
   */
  ;
  {
    int __gen_e_acsl_exists_4;
    int __gen_e_acsl_i_12;
    int __gen_e_acsl_j_7;
    int __gen_e_acsl_k_7;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_20 =
      {.values = (void *)0};
    __gen_e_acsl_exists_4 = 0;
    __gen_e_acsl_i_12 = 0;
    while (1) {
      if (__gen_e_acsl_i_12 < 10) ; else break;
      __gen_e_acsl_j_7 = __gen_e_acsl_i_12;
      while (1) {
        if (__gen_e_acsl_j_7 < 10) ; else break;
        __gen_e_acsl_k_7 = __gen_e_acsl_j_7 + 1;
        while (1) {
          if (__gen_e_acsl_k_7 <= 10) ; else break;
          {
            int __gen_e_acsl_p2_4;
            __gen_e_acsl_p2_4 = __gen_e_acsl_p2(__gen_e_acsl_i_12,
                                                __gen_e_acsl_j_7,
                                                __gen_e_acsl_k_7);
            if (! __gen_e_acsl_p2_4) ;
            else {
              __gen_e_acsl_exists_4 = 1;
              goto e_acsl_end_loop18;
            }
          }
          __gen_e_acsl_k_7 ++;
        }
        __gen_e_acsl_j_7 ++;
      }
      __gen_e_acsl_i_12 ++;
    }
    e_acsl_end_loop18: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_20,
                                 "exists_multiple_binders_2:\n  \\exists integer i, integer j, integer k;\n    0 <= i <= j < k <= 10 && p2(i, j, k)",
                                 0,__gen_e_acsl_exists_4);
    __gen_e_acsl_assert_data_20.blocking = 1;
    __gen_e_acsl_assert_data_20.kind = "Assertion";
    __gen_e_acsl_assert_data_20.pred_txt = "exists_multiple_binders_2:\n  \\exists integer i, integer j, integer k;\n    0 <= i <= j < k <= 10 && p2(i, j, k)";
    __gen_e_acsl_assert_data_20.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_20.fct = "main";
    __gen_e_acsl_assert_data_20.line = 71;
    __e_acsl_assert(__gen_e_acsl_exists_4,& __gen_e_acsl_assert_data_20);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_20);
  }
  /*@
  assert
  exists_multiple_binders_2:
    \exists integer i, integer j, integer k;
      0 <= i <= j < k <= 10 && p2(i, j, k);
   */
  ;
  {
    int __gen_e_acsl_exists_5;
    int __gen_e_acsl_i_13;
    int __gen_e_acsl_j_8;
    int __gen_e_acsl_k_8;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_21 =
      {.values = (void *)0};
    __gen_e_acsl_exists_5 = 0;
    __gen_e_acsl_i_13 = 0;
    while (1) {
      if (__gen_e_acsl_i_13 < 10) ; else break;
      __gen_e_acsl_j_8 = __gen_e_acsl_i_13 + 1;
      while (1) {
        if (__gen_e_acsl_j_8 <= 10) ; else break;
        __gen_e_acsl_k_8 = 1 + 1;
        while (1) {
          if (__gen_e_acsl_k_8 < 11) ; else break;
          {
            int __gen_e_acsl_p3_4;
            __gen_e_acsl_p3_4 = __gen_e_acsl_p3(__gen_e_acsl_i_13,
                                                __gen_e_acsl_j_8,
                                                __gen_e_acsl_k_8);
            if (! __gen_e_acsl_p3_4) ;
            else {
              __gen_e_acsl_exists_5 = 1;
              goto e_acsl_end_loop19;
            }
          }
          __gen_e_acsl_k_8 ++;
        }
        __gen_e_acsl_j_8 ++;
      }
      __gen_e_acsl_i_13 ++;
    }
    e_acsl_end_loop19: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_21,
                                 "exists_multiple_binders_3:\n  \\exists integer i, integer j, integer k;\n    0 <= i < j <= 10 && 1 < k < 11 && p3(i, j, k)",
                                 0,__gen_e_acsl_exists_5);
    __gen_e_acsl_assert_data_21.blocking = 1;
    __gen_e_acsl_assert_data_21.kind = "Assertion";
    __gen_e_acsl_assert_data_21.pred_txt = "exists_multiple_binders_3:\n  \\exists integer i, integer j, integer k;\n    0 <= i < j <= 10 && 1 < k < 11 && p3(i, j, k)";
    __gen_e_acsl_assert_data_21.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_21.fct = "main";
    __gen_e_acsl_assert_data_21.line = 74;
    __e_acsl_assert(__gen_e_acsl_exists_5,& __gen_e_acsl_assert_data_21);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_21);
  }
  /*@
  assert
  exists_multiple_binders_3:
    \exists integer i, integer j, integer k;
      0 <= i < j <= 10 && 1 < k < 11 && p3(i, j, k);
   */
  ;
  {
    int __gen_e_acsl_exists_6;
    int __gen_e_acsl_i_14;
    int __gen_e_acsl_k_9;
    int __gen_e_acsl_j_9;
    __e_acsl_assert_data_t __gen_e_acsl_assert_data_22 =
      {.values = (void *)0};
    __gen_e_acsl_exists_6 = 0;
    __gen_e_acsl_i_14 = 0;
    while (1) {
      if (__gen_e_acsl_i_14 <= 10) ; else break;
      __gen_e_acsl_k_9 = __gen_e_acsl_i_14;
      while (1) {
        if (__gen_e_acsl_k_9 <= 10) ; else break;
        __gen_e_acsl_j_9 = 1;
        while (1) {
          if (__gen_e_acsl_j_9 < __gen_e_acsl_k_9) ; else break;
          {
            int __gen_e_acsl_p4_4;
            __gen_e_acsl_p4_4 = __gen_e_acsl_p4(__gen_e_acsl_i_14,
                                                __gen_e_acsl_j_9,
                                                __gen_e_acsl_k_9);
            if (! __gen_e_acsl_p4_4) ;
            else {
              __gen_e_acsl_exists_6 = 1;
              goto e_acsl_end_loop20;
            }
          }
          __gen_e_acsl_j_9 ++;
        }
        __gen_e_acsl_k_9 ++;
      }
      __gen_e_acsl_i_14 ++;
    }
    e_acsl_end_loop20: ;
    __e_acsl_assert_register_int(& __gen_e_acsl_assert_data_22,
                                 "exists_unordered_binders:\n  \\exists integer i, integer j, integer k;\n    0 <= i <= k <= 10 && 1 <= j < k && p4(i, j, k)",
                                 0,__gen_e_acsl_exists_6);
    __gen_e_acsl_assert_data_22.blocking = 1;
    __gen_e_acsl_assert_data_22.kind = "Assertion";
    __gen_e_acsl_assert_data_22.pred_txt = "exists_unordered_binders:\n  \\exists integer i, integer j, integer k;\n    0 <= i <= k <= 10 && 1 <= j < k && p4(i, j, k)";
    __gen_e_acsl_assert_data_22.file = "tests/arith/quantif.i";
    __gen_e_acsl_assert_data_22.fct = "main";
    __gen_e_acsl_assert_data_22.line = 77;
    __e_acsl_assert(__gen_e_acsl_exists_6,& __gen_e_acsl_assert_data_22);
    __e_acsl_assert_clean(& __gen_e_acsl_assert_data_22);
  }
  /*@
  assert
  exists_unordered_binders:
    \exists integer i, integer j, integer k;
      0 <= i <= k <= 10 && 1 <= j < k && p4(i, j, k);
   */
  ;
  /*@
  assert
  failed_invalid_guards: \forall integer i; 10 > i >= 0 ==> p1(i, 2, 2); */
  ;
  /*@
  assert
  failed_unguarded_k:
    \forall integer i, integer j, integer k;
      0 <= i < 10 && 1 < j <= 11 ==> p1(i, j, k);
   */
  ;
  /*@
  assert
  failed_non_integer: \forall real i; 0 <= i < 10 ==> p1(\truncate(i), 2, 2);
   */
  ;
  /*@
  assert
  failed_missing_lower_bound: \forall integer i; i < 10 ==> p1(i, 2, 2); */
  ;
  /*@
  assert
  failded_missing_upper_bound: \forall integer i; 0 <= i ==> p1(i, 2, 2); */
  ;
  /*@
  assert
  failed_invalid_upper_bound_1:
    \forall integer i, integer j; 0 <= i < j ==> p1(i, j, 2);
   */
  ;
  /*@
  assert
  failed_invalid_upper_bound_2:
    \forall integer i, integer j; i < j && 0 <= i ==> p1(i, 2, 2);
   */
  ;
  /*@
  assert
  failed_extra_constraint:
    \forall integer i, integer j;
      0 <= i < j && i < 10 && 3 <= j < 5 ==> p1(i, j, 2);
   */
  ;
  /*@
  assert
  failed_multiple_upper_bounds:
    \forall integer i, integer j; 0 <= i < j < i && j <= 10 ==> p1(i, j, 2);
   */
  ;
  /*@
  assert
  multiple_linked_upper:
    \forall integer i, integer j, integer k;
      0 <= i < k && 1 <= j < k && 2 <= k < 10 ==> p1(i, j, k);
   */
  ;
  /*@
  assert
  multiple_guard:
    \forall integer i, integer j;
      0 <= i < 10 && 2 <= i < 8 && 4 <= j < 6 ==> p1(i, j, 2);
   */
  ;
  __retres = 0;
  __e_acsl_memory_clean();
  return __retres;
}

/*@ assigns \result;
    assigns \result \from i, j, k; */
int __gen_e_acsl_p1(int i, int j, int k)
{
  int __gen_e_acsl_and;
  int __gen_e_acsl_and_2;
  int __gen_e_acsl_and_3;
  int __gen_e_acsl_and_4;
  int __gen_e_acsl_and_5;
  if (0 <= i) __gen_e_acsl_and = i < 10; else __gen_e_acsl_and = 0;
  if (__gen_e_acsl_and) __gen_e_acsl_and_2 = 1 < j;
  else __gen_e_acsl_and_2 = 0;
  if (__gen_e_acsl_and_2) __gen_e_acsl_and_3 = j <= 11;
  else __gen_e_acsl_and_3 = 0;
  if (__gen_e_acsl_and_3) __gen_e_acsl_and_4 = 2 <= k;
  else __gen_e_acsl_and_4 = 0;
  if (__gen_e_acsl_and_4) __gen_e_acsl_and_5 = k <= 12;
  else __gen_e_acsl_and_5 = 0;
  return __gen_e_acsl_and_5;
}

/*@ assigns \result;
    assigns \result \from i, j, k; */
int __gen_e_acsl_p2(int i, int j, int k)
{
  int __gen_e_acsl_and_6;
  int __gen_e_acsl_and_7;
  int __gen_e_acsl_and_8;
  if (0 <= i) __gen_e_acsl_and_6 = i <= j; else __gen_e_acsl_and_6 = 0;
  if (__gen_e_acsl_and_6) __gen_e_acsl_and_7 = j < k;
  else __gen_e_acsl_and_7 = 0;
  if (__gen_e_acsl_and_7) __gen_e_acsl_and_8 = k <= 10;
  else __gen_e_acsl_and_8 = 0;
  return __gen_e_acsl_and_8;
}

/*@ assigns \result;
    assigns \result \from i, j, k; */
int __gen_e_acsl_p3(int i, int j, int k)
{
  int __gen_e_acsl_and_9;
  int __gen_e_acsl_and_10;
  int __gen_e_acsl_and_11;
  int __gen_e_acsl_and_12;
  if (0 <= i) __gen_e_acsl_and_9 = i < j; else __gen_e_acsl_and_9 = 0;
  if (__gen_e_acsl_and_9) __gen_e_acsl_and_10 = j <= 10;
  else __gen_e_acsl_and_10 = 0;
  if (__gen_e_acsl_and_10) __gen_e_acsl_and_11 = 1 < k;
  else __gen_e_acsl_and_11 = 0;
  if (__gen_e_acsl_and_11) __gen_e_acsl_and_12 = k < 11;
  else __gen_e_acsl_and_12 = 0;
  return __gen_e_acsl_and_12;
}

/*@ assigns \result;
    assigns \result \from i, j, k; */
int __gen_e_acsl_p4(int i, int j, int k)
{
  int __gen_e_acsl_and_13;
  int __gen_e_acsl_and_14;
  int __gen_e_acsl_and_15;
  int __gen_e_acsl_and_16;
  if (0 <= i) __gen_e_acsl_and_13 = i <= k; else __gen_e_acsl_and_13 = 0;
  if (__gen_e_acsl_and_13) __gen_e_acsl_and_14 = k <= 10;
  else __gen_e_acsl_and_14 = 0;
  if (__gen_e_acsl_and_14) __gen_e_acsl_and_15 = 1 <= j;
  else __gen_e_acsl_and_15 = 0;
  if (__gen_e_acsl_and_15) __gen_e_acsl_and_16 = j < k;
  else __gen_e_acsl_and_16 = 0;
  return __gen_e_acsl_and_16;
}


